#ifndef STA_CORE_ARDUINO_I2C_HPP
#define STA_CORE_ARDUINO_I2C_HPP

#include <sta/config.hpp>
#ifdef STA_PLATFORM_ARDUINO

#include <sta/bus/i2c/device.hpp>
#include <sta/bus/i2c/i2c.hpp>

namespace sta
{
    class ArduinoI2C : public I2C
    {    
    public:
        ArduinoI2C(Mutex * mutex=nullptr, uint16_t address);

        void transfer16(uint16_t value) override;
        void transfer(const uint8_t * buffer, size_t size) override;
        void transfer(const uint8_t * txBuffer, uint8_t * rxBuffer, size_t size) override;
        void receive(uint8_t * buffer, size_t size) override;
        void fill(uint8_t value, size_t count) override;

        void acquire();
        void release();
    };

    class ArduinoI2CDevice : public I2CDevice
    {
    public:
        ArduinoI2CDevice(I2C * intf, int address, bool master=false, bool blocking=true);
    };    
} // namespace sta

#endif // STA_PLATFORM_ARDUINO

#endif // STA_CORE_ARDUINO_I2C_HPP