#include <sta/devices/arduino/bus/i2c.hpp>

#ifdef STA_PLATFORM_ARDUINO

#include <sta/devices/arduino/hal.hpp>


namespace sta
{
    ArduinoI2C::ArduinoI2C(Mutex * mutex, uint16_t address)
        : I2C{mutex}
    {
        Wire.begin(address);
    }

    void ArduinoI2C::transfer16(uint16_t value)
    {
        Wire.write(value);
    }

    void ArduinoI2C::transfer(const uint8_t * buffer, size_t size)
    {
        Wire.write(buffer, size);
    }

    void ArduinoI2C::transfer(const uint8_t * txBuffer, uint8_t * rxBuffer, size_t size)
    {
        // NOT REALLY A THING HERE, IS IT?
    }

    void ArduinoI2C::receive(uint8_t * buffer, size_t size)
    {
        
    }

    void ArduinoI2C::fill(uint8_t value, size_t count)
    {
        // Initialize a buffer of size count and fill it with the value.
        uint8_t *buffer = new uint8_t[count];
        memset(buffer, value, count);

        Serial.write(buffer, count);

        delete [] buffer; 
    }

    void ArduinoI2C::acquire()
    {
        I2C::acquire();

        Wire.beginTransmission(address_);
    }

    void ArduinoI2C::release()
    {
        Wire.endTransmission();

        I2C::release();
    }

    ArduinoI2CDevice::ArduinoI2CDevice(I2C * intf, int address, bool master, bool blocking)
        : I2CDevice{intf, address, master, blocking}
    {

    }
} // namespace sta

#endif // STA_PLATFORM_ARDUINO